<?php
/*
 Plugin Name: Cred Paywall
 Plugin URI: http://www.yourcred.com/plugins/wordpress
 Description: This plugin allows you to generate revenue from your blog by integrating to the Cred micro-payment system. This effectively puts a paywall on your site for content you choose to be paywalled. Cred is a micro-payment system tailored specifically for content. From news, audio, video and music as well as any virtual content we provide a payment method for that content. Instead of the user having to tediously enter their credit card details into every site they buy content on, they rather enter it once and redeem wherever the Cred system is available. Visit http://www.yourcred.com for more information. 
 Version: 0.7.1
 Author: YourCred.com
 Author URI: http://www.yourcred.com/
 */

define('CRED_VERSION', '0.7.1');
include("compat.php");

function cred_init() {
	global $cred_api_key;

	add_action('admin_menu', 'cred_config_page');
	cred_admin_warnings();

	$user = wp_get_current_user();
   $cred_user_id = get_usermeta($user->ID, 'cred_id');
	
	// check for a login request
	if ( $_POST['cred_login'] != null ) {
		if ( $user == null || $user->ID == 0 ) {
			$user = cred_user_login( $_POST['username'], $_POST['usercode'] );
			if (is_wp_error($user)) {
				echo "<script>alert('Authentication error: " . $user->get_error_message() . "'); window.cred_auth_error=true;</script>";
			}
		}
	}

   if ($cred_user_id != null) {
	   // check for subscription request
	   if ( $_POST['cred_subscription_uri'] != null ) {
	      $api_call = "/api/user/subscribe/".
	      $cred_user_id.".json?usercode=".$_POST['token'].
	              "&api_key=".get_option("cred_api_key").
	              "&uri=".$_POST['cred_subscription_uri'];
	      $output = cred_get_contents($api_call);
	      if ($output == FALSE) $post->post_excerpt .= "<script>" .
	           "alert('Unable to connect to Cred server. Please try again later.');</script>";
	      $obj = json_decode($output, true);
	      if ($obj['error']) {
	         /*if ($obj['exception'] == "User does not have enough cred") {
	          $obj['exception'] .= ". <a href='". CRED_URL . "/user' target='_blank'>Click here to buy more cred</a>";
	          }*/
	         echo "<script>alert('Unable to redeem: ".$obj['exception'] . "');</script>";
	      } else {
	         // reload subscriptions
	         cred_get_user_subscriptions(get_usermeta($user->ID, 'cred_id'), $user->ID);
	
	         return $content;
	      }
	   }
	
	   // check for subscription expiry
	   $expiry_string = get_usermeta($user->ID, 'cred_next_expiry');
	   if ( $expiry_string != null ) {
	   	$expiry = strtotime($expiry_string);
         //var_dump($expiry - strtotime("now"));
	   	if ($expiry - strtotime("now") <= 0) {
            // reload subscriptions
            cred_get_user_subscriptions(get_usermeta($user->ID, 'cred_id'), $user->ID);	   		
	   	}
	   }   	
   }
}
add_action('init', 'cred_init');

function cred_admin_warnings() {
	global $cred_api_key;

	if ( !get_option('cred_api_key') && !$cred_api_key && !isset($_POST['submit']) ) {
		function cred_warning() {
			echo "
			<div id='cred-warning' class='updated fade'>
			<p><strong>".__('Cred is almost ready.')."</strong> 
			".sprintf(__('You must <a href="%1$s">enter your YourCred.com API key</a> for it to work.'), 
			   "plugins.php?page=cred-key-config")."
			</p></div>
			";
		}
		add_action('admin_notices', 'cred_warning');
		return;
	}
}

// Our own version of file_get_contents without the security restrictions
function cred_get_contents($url,$include_headers=false,$post=false) {
	$url = parse_url(CRED_SERVER . $url);

	if (!isset($url['port'])) {
		if ($url['scheme'] == 'http') { $url['port']=80; }
		elseif ($url['scheme'] == 'https') { $url['port']=443; }
	}
	$url['query']=isset($url['query'])?$url['query']:'';

	$url['protocol']=$url['scheme'].'://';
	$eol="\r\n";

	$headers =  "POST ".$url['protocol'].$url['host'].$url['path']." HTTP/1.0".$eol.
                "Host: ".$url['host'].$eol.
                "Referer: ".$url['protocol'].$url['host'].$url['path'].$eol.
                "Content-Type: application/x-www-form-urlencoded".$eol.
                "Content-Length: ".strlen($url['query']).$eol.
	$eol.$url['query'];

	$fp = @fsockopen($url['host'], $url['port'], $errno, $errstr, 30);
	if($fp) {
		if ($post) fputs($fp, $headers);
		else fputs($fp, "GET " . $url['path'] . "?" . $url['query'] . " HTTP/1.1\r\n".
                     "Host: " . $url['host'] . "\r\nConnection: Close\r\n\r\n");
		$result = '';
		while($fp && !feof($fp)) { $result .= fgets($fp, 128); }
		fclose($fp);
		if (!$include_headers) {
			//removes headers
			$pattern="/^.*\r\n\r\n/s";
			$result=preg_replace($pattern,'',$result);
		}

		return $result;
	} else {
		return false;
	}
}

function cred_config_page() {
	if ( function_exists('add_submenu_page') )
	add_submenu_page('plugins.php', __('Cred Configuration'), __('Cred Configuration'), 'manage_options', 'cred-key-config', 'cred_conf');

}

function cred_conf() {
	global $cred_api_key;

	if ( isset($_POST['submit']) ) {
		if ( function_exists('current_user_can') && !current_user_can('manage_options') )
		die(__('Cheatin&#8217; uh?'));

		//$key = preg_replace( '/[^a-h0-9]/i', '', $_POST['key'] );
		$key = $_POST['key'];

		if ( empty($key) ) {
			delete_option('cred_api_key');
		} else {
			add_option('cred_api_key', $key);
			update_option('cred_api_key', $key);
		}
		$cred_api_key = $key;
	}

?>

   <?php if ( !empty($_POST['submit'] ) ) : ?>
		<div id="message" class="updated fade">
		<p><strong><?php _e('Options saved.') ?></strong></p>
		</div>
	<?php endif; ?>
		
	<div class="wrap">
	<h2><?php _e('Cred Configuration'); ?></h2>
	<div class="narrow">
	<form action="" method="post" id="cred-conf"
		style="margin: auto; width: 400px;">
<?php if ( !$cred_api_key ) { ?>
	     <p>
	     <?php printf(__('Use Cred to paywall your blog so that you can generate revenue from it.'), CRED_URL, 
	           CRED_URL . '/plugins/wordpress'); ?>
	     </p>
<?php } ?>
	<h3><label for="key"><?php _e('YourCred.com API Key'); ?></label></h3>
	<p><input id="key" name="key" type="text" size="40" maxlength="50"
		value="<?php echo get_option('cred_api_key'); ?>"
		style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;" />
	(<?php _e('<a href="'.CRED_URL.'/welcome/provider_signup_form">Sign up for an API key</a>'); ?>)</p> <br />
	
	<p class="submit"><input type="submit" name="submit"
		value="<?php _e('Update options &raquo;'); ?>" /></p>
	</form>
	</div>
	</div>

<?php
} // cred_conf()

/* Use the admin_menu action to define the custom boxes */
add_action('admin_menu', 'cred_add_custom_box');

/* Use the save_post action to do something with the data entered */
add_action('save_post', 'cred_save_postdata');

/* Adds a custom section to the "advanced" Post and Page edit screens */
function cred_add_custom_box() {

	if( function_exists( 'add_meta_box' )) {
		add_meta_box( 'cred_sectionid', __( 'Cred Options', 'cred_textdomain' ),
                'cred_inner_custom_box', 'post', 'advanced' );
		add_meta_box( 'cred_sectionid', __( 'Cred Options', 'cred_textdomain' ),
                'cred_inner_custom_box', 'page', 'advanced' );
	} else {
		add_action('dbx_post_advanced', 'cred_old_custom_box' );
		add_action('dbx_page_advanced', 'cred_old_custom_box' );
	}
}

/* Prints the inner fields for the custom post/page section */
function cred_inner_custom_box( $post ) {

	// Use nonce for verification

	echo '<input type="hidden" name="cred_noncename" id="cred_noncename" value="' .
	wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

	// The actual fields for data entry
	$is_paid = "";
	if ( get_post_meta($post->ID, 'cred_paywall', true) == "1" ) {
		$is_paid = "checked";
	}
	?>
<table border="0">
	<tr>
		<td></td>
		<td><input type="checkbox" name="cred_paywall" value="1"
		<?php echo($is_paid) ?>> Make this post paid-for content</td>
	</tr>
	<tr>
		<td><b>Price in cred:</b></td>
		<td><input type="text" name="cred_price"
			value="<?php echo(get_post_meta($post->ID, 'cred_price', true)) ?>" />
		</td>
	</tr>
</table>
		<?php
}

/* Prints the edit form for pre-WordPress 2.5 post/page */
function cred_old_custom_box( $post ) {

	echo '<div class="dbx-b-ox-wrapper">' . "\n";
	echo '<fieldset id="cred_fieldsetid" class="dbx-box">' . "\n";
	echo '<div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">' .
	__( 'Cred Options', 'cred_textdomain' ) . "</h3></div>";

	echo '<div class="dbx-c-ontent-wrapper"><div class="dbx-content">';

	// output editing form

	cred_inner_custom_box( $post );

	// end wrapper

	echo "</div></div></fieldset></div>\n";
}

/* When the post is saved, saves our custom data */
function cred_save_postdata( $post_id ) {

	// verify this came from the our screen and with proper authorization,
	// because save_post can be triggered at other times

	if ( !wp_verify_nonce( $_POST['cred_noncename'], plugin_basename(__FILE__) )) {
		return $post_id;
	}

	// verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
	// to do anything
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
	return $post_id;


	// Check permissions
	if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post_id ) )
		return $post_id;
	} else {
		if ( !current_user_can( 'edit_post', $post_id ) )
		return $post_id;
	}

	// OK, we're authenticated: we need to find and save the data
	$paywall = $_POST['cred_paywall'] or '0';
	add_post_meta($post_id, 'cred_paywall', $paywall, true) or update_post_meta($post_id, 'cred_paywall', $paywall);
	$price = $_POST['cred_price'] or '0';
	add_post_meta($post_id, 'cred_price', $price, true) or update_post_meta($post_id, 'cred_price', $price);

	return $post_id;
}

//add_filter("wp_head", "cred_head");
/**
 * Add our stylesheets and javascript to the head. Some themes stop wp_head function from working,
 * so instead, we will load this as and when needed (e.g. cred_content_filter)
 */
function cred_head() {
   global $cred_loaded;

   if ($cred_loaded) return;
   $cred_loaded = true;
   
	$logged_in = false;
	$user = wp_get_current_user();
	if ($user->ID > 0) {
		$logged_in = true;
      $cred_user = get_usermeta($user->ID, 'cred_user');
	}
?>
	<link rel="stylesheet"
		href="<?php echo WP_PLUGIN_URL ?>/cred/cred.css" type="text/css"
		media="screen" />
	<script
		type="text/javascript"
		src="<?php echo WP_PLUGIN_URL ?>/cred/jsr_class.js"></script>
	<script
		type="text/javascript" src="<?php echo WP_PLUGIN_URL ?>/cred/center.js"></script>
	<script
		type="text/javascript" src="<?php echo WP_PLUGIN_URL ?>/cred/cred.js"></script>
	<script type="text/javascript">
	   	cred.init('<?php echo CRED_URL ?>', '<?php echo get_option("cred_api_key") ?>', <?php 
		       echo $logged_in ? 'true' : 'false' ?>, '<?php echo WP_PLUGIN_URL ?>', <?php 
		       echo $cred_user ? 'true' : 'false' ?>);
	</script>
<?php
}

//add_filter( "the_excerpt", "cred_filter_excerpt" );
/**
 * Filter the content from the user unless already purchased. Provide a link for users to login
 * or purchase the content otherwise.
 * @param $content
 * @return unknown_type
 */
function cred_filter_excerpt( $excerpt ) {
   global $post;
   
   $is_paywalled = cred_is_paywalled( $post );
   if (is_wp_error($is_paywalled)) {
      return "<script>cred.error('" . $is_paywalled->get_error_message() . "');</script>";   	
   }   
   
   if ($is_paywalled) {
   	return $excerpt . "<br clear='all'/><br clear='all'/><div class='credLogoSmall' id='cred_".$post->ID."' onclick='cred.purchase(this, \"?p=" .
      $post->ID . "\", \"" . urlencode($post->post_title) . "\", " . get_post_meta($post->ID, 'cred_price', true) . 
      ")'> Click here to redeem for " .
      get_post_meta($post->ID, 'cred_price', true) . " cred</div>";
   }
   
   return $excerpt;
}	

add_filter( "the_content", "cred_filter_content" );
/**
 * Filter the content from the user unless already purchased. Provide a link for users to login
 * or purchase the content otherwise.
 * @param $content
 * @return unknown_type
 */
function cred_filter_content( $content ) {
   global $post;

   if (cred_is_paywall_flagged($post)) {
   	// this is paywall content, so load up our js and css files
   	cred_head();
   }
   
	$is_paywalled = cred_is_paywalled( $post );

   if (is_wp_error($is_paywalled)) {
   	return "<script>cred.error('" . $is_paywalled->get_error_message() . "');</script>";
   }

   if ($is_paywalled) {
   	// paywalled content display
	   $content = $post->post_excerpt . "<br clear='all'/><br clear='all'/>" .
	     "<div class='credLogoSmall' id='cred_" .
		     $post->ID . "' onclick='cred.purchase(this, \"?p=" .
		     $post->ID . "\", \"" . urlencode($post->post_title) . "\", " . 
		     get_post_meta($post->ID, 'cred_price', true) . 
	     ")'> Click here to redeem for " . get_post_meta($post->ID, 'cred_price', true) . " cred" .
		  "</div>";		     
   }
   
   return $content;
}

/**
 * Tests post to see if it's marked as paywalled
 */
function cred_is_paywall_flagged( $post ) {
   // Cred paywalled content
   if ( get_post_meta($post->ID, 'cred_paywall', true) == "1" ) {
      return true;
   }
   
   return false;
}

/**
 * Function to test if the specified post is paywalled or not for the current user
 * @return unknown_type
 */
function cred_is_paywalled( $post ) {

   // Content authors can view their content without purchase
   if ( current_user_can( 'edit_post', $post->ID ) ) {
      return false;
   }
   
   // Non-paywalled content
   if ( get_post_meta($post->ID, 'cred_paywall', true) != "1" ) {
      return false;
   }   

	// check if the logged in user is a cred user
   $user = wp_get_current_user();
   $cred_user = get_usermeta($user->ID, 'cred_user');
   if ($cred_user) {
      // check if user has already purchased this content or subscribed
      $purchased = false;

      // get the user subscriptions
      $subs = (array)get_usermeta($user->ID, 'cred_subscriptions');
      if (!$purchased && in_array("/full", $subs)) {
         $purchased = true;
      }

      // get the user purchases
      if (!$purchased) {
         $p = (array)get_usermeta($user->ID, 'cred_purchases');
         if (in_array("?p=".$post->ID, $p)) {
            $purchased = true;
         }
      }

      if ($purchased) return false;

      // check for a purchase request
      if ( ("?p=".$post->ID) == $_POST['cred_purchase_post_uri'] ) {
         $user = wp_get_current_user();
         $cred_user_id = get_usermeta($user->ID, 'cred_id');

         $api_call = "/api/user/purchase/".
         $cred_user_id.".json?usercode=".$_POST['token'].
                "&api_key=".get_option("cred_api_key").
                "&uri=".urlencode("?p=").$post->ID.
             "&title=".urlencode($post->post_title).
              "&creds=".get_post_meta($post->ID, 'cred_price', true);
         $output = cred_get_contents($api_call);
         if ($output == FALSE) return new WP_Error('Unable to connect to Cred server. Please try again later.');
         $obj = json_decode($output, true);
         if ($obj['error']) {
            /*if ($obj['exception'] == "User does not have enough cred") {
             $obj['exception'] .= ". <a href='". CRED_URL . "/user' target='_blank'>Click here to buy more cred</a>";
             }*/
            return new WP_Error('Unable to redeem: '.$obj['exception']);
         } else {
            // add purchase to user's purchased list
            $p = (array)get_usermeta($user->ID, 'cred_purchases');
            array_push($p, "?p=".$post->ID);
            update_usermeta($user->ID, 'cred_purchases', $p);
               
            return false;
         }
      }
   }
	
   return true;
}

//MVW  -- Add title filter and its function
add_filter( "the_title", "cred_filter_title" );
function cred_filter_title( $title ){
	global $post;
   global $cred_title_icon_small;
   global $cred_title_icon_medium;
   global $cred_title_icon_large;

   if (cred_is_paywall_flagged($post)) {
      $cred_title_icon_small =  "<img src='".WP_PLUGIN_URL."/cred/icon_cred_16x16.png' width='16' height='16' alt='Cr'/>";   	
      $cred_title_icon_medium =  "<img src='".WP_PLUGIN_URL."/cred/icon_cred_24x24.png' width='24' height='24' alt='Cr'/>";    
      $cred_title_icon_large =  "<img src='".WP_PLUGIN_URL."/cred/icon_cred_32x32.png' width='32' height='32' alt='Cr'/>";    
   } else {
      $cred_title_icon_small =  "";    
      $cred_title_icon_medium =  "";    
      $cred_title_icon_large =  "";       	
   }
   
	return $title;
}

add_filter("wp_footer", "cred_footer");
// Additional divs/javascript
function cred_footer() {
	$user = wp_get_current_user();
	?>
<!-- Redeem Cred: Start -->
<div class="credRedeem" id="redeemCred" style="display: none">
<form name="credRedeemForm">
<fieldset class="redeemCred"><legend>Redeem Cred</legend> You are about
to redeem an item for <strong><span id="redeemCredValue"></span></strong>
cred. Are you sure?<br />
	<?php
	$subs = get_usermeta($user->ID, 'cred_provider_subscriptions');
	if (is_array($subs) && $subs[0] != null) {
		echo "<br/>The following subscriptions are also available for this website, select one to ".
                     	  "subscribe rather than redeem the single item:<br/><br/>";

		foreach($subs as $s) {
			echo '<input type="radio" name="cred_subscription_uri" value="'.
			$s["subscription_uri"].'"/>'.$s["name"].', '.
			$s["duration"].' - '.$s["cred_cost"].' cred<br/>';
		}

		echo '<input type="radio" name="cred_subscription_uri" value="" checked="checked"/>Not right now, thanks<br/><br/>';
	}
	?> <input type="button" value="OK"
	onclick="cred._doPurchase();document.getElementById('redeemCred').style.display='none';">
<input type="button" value="Cancel"
	onClick="document.getElementById('redeemCred').style.display='none'"></fieldset>
</form>
</div>
<div class="credRedeem" id="credMessage" style="display: none">
<fieldset class="redeemCred"><legend>Cred</legend> <img
	src="<?php echo WP_PLUGIN_URL ?>/cred/loading.gif" alt="Loading" /> <span
	id="credMessageText"></span></fieldset>
</div>
<!-- Redeem Cred: End -->
	<?php
}

/**
 * Do not allow paid content into the RSS feed
 */
add_filter( "the_content_rss", "cred_filter_rss_content" );
function cred_filter_rss_content( $content ) {
	global $post;

	if ( get_post_meta($post->ID, 'cred_paywall', true) == "1" ) {
		return $post->post_excerpt . "\r\n<br/><br/>View the full content on the website.";
	} else {
		return $content;
	}
}

/* set up callback for authentication */
function cred_auth_start() {
	$loc = $_GET['loc'];

	$uri = explode('#',$loc);
	$url = $uri[0];

	$_SESSION['cred_auth_callback'] = $url;
}

/*add_action( "authenticate", "cred_authenticate", 10, 3 );*/
/* change the authenticate mechanism to use YourCred.com authentication */
function cred_authenticate( $user, $username, $password ) {

	if ( $user == null && $username != null ) {
		$username = sanitize_user($username);
		$password = trim($password);

		// check if user is a WP user
		$user = get_userdatabylogin($username);
		if ( $user != null ) return null;

		// User is not a wordpress user, so log them into Cred
		cred_user_login($username, $password);
	}

	return $user;
}

/* Log the user into their YourCred.com account */
function cred_user_login( $username, $password ) {
	try {
		$output = cred_get_contents("/api/user/login/".
		$username.".json?usercode=".$password."&api_key=".get_option("cred_api_key"));
		if ($output == FALSE) throw new Exception("Unable to connect to authentication server for login. Please try again later.");
		$obj = (array)json_decode($output);
		$udata = (array)$obj['user'];
		if ($obj['error']) {
			return new WP_Error('authentication_failed', __('Cred authentication failed.'));
		}
	} catch (Exception $e) {
		return new WP_Error('error', __($e->getMessage()));
		//return new WP_Error('authentication_failed', __('Cred authentication failed.'.$e->getMessage()));
	}

	$wpusername = cred_username_to_wpusername($username);
	// update user data
	$userdata = array(
          'user_pass' => wp_generate_password(),
          'user_login' => $wpusername,
          'first_name' => $udata["firstname"],
          'last_name' => $udata["surname"],
          'display_name' => $udata["firstname"]." ".$udata["surname"],
          'user_url' => CRED_URL . "/users/".$username,
          'user_email' =>  ""
	);

   define( 'WP_IMPORTING', 'true' ); // For wordpress 3.0, skip dup email check
	$user = get_userdatabylogin($wpusername);
	if ( $user == null || is_wp_error($user) ) {
		// first time logging in from this site
		$user = new WP_User($wpusername);
		if(!function_exists('wp_insert_user'))
		{
			include_once( ABSPATH . WPINC . '/registration.php' );
		}

		$wpuid = wp_insert_user($userdata);
		if ( is_wp_error($wpuid) ) {
			wp_die($wpuid->get_error_message());
		}
	} else {
		if(!function_exists('wp_update_user'))
		{
			include_once( ABSPATH . WPINC . '/registration.php' );
		}
		$wpuid = $user->ID;
		$userdata["ID"] = $wpuid;
		wp_update_user($userdata);
	}
	
	if($wpuid) {
      delete_usermeta($wpuid, 'cred_user');
      delete_usermeta($wpuid, 'cred_id');
      delete_usermeta($wpuid, 'cred_balance');
      delete_usermeta($wpuid, 'cred_provider_subscriptions');
		
      cred_get_user_purchases($username, $wpuid);
      cred_get_user_subscriptions($username, $wpuid);
      
		$cred_subs = cred_get_contents("/api/provider/subscriptions.json?api_key=".
		get_option("cred_api_key"));
		if ($cred_subs == FALSE) {
			return new WP_Error('error', __("Unable to connect to Cred server for subscriptions. Please try again later."));
		}
		$s = (array)json_decode($cred_subs, true);
		if (is_array($s["subscriptions"])) {
			$cred_subs = $s["subscriptions"];
		} else {
			$cred_subs = array();
		}

		update_usermeta($wpuid, 'cred_user', true);
		update_usermeta($wpuid, 'cred_id', $udata['username']);
		update_usermeta($wpuid, 'cred_balance', "".$udata['cred_balance']);
		update_usermeta($wpuid, 'cred_provider_subscriptions', $cred_subs);

		wp_set_auth_cookie($wpuid, false, true);
		wp_set_current_user($wpuid);
	}

	return $user;
}

/* Load user content redemptions from Cred server */
function cred_get_user_purchases($username, $wpuid) {
   delete_usermeta($wpuid, 'cred_purchases');
   
	// get the user purchases
	$purchases = cred_get_contents("/api/user/purchases/".
	$username.".json?&api_key=".get_option("cred_api_key"));
	if ($purchases == FALSE) {
		return new WP_Error('error', __("Unable to connect to authentication server for purchases. Please try again later."));
	}
	$p = (array)json_decode($purchases);
	if (is_array($p['purchases'])) {
		$p2 = array_map("cred_purchases_array_map", $p['purchases']);
	} else {
		$p2 = array();
	}

	update_usermeta($wpuid, 'cred_purchases', $p2);
}

/* Load user subscriptions from Cred server */
function cred_get_user_subscriptions($username, $wpuid) {
	delete_usermeta($wpuid, 'cred_subscriptions');
	delete_usermeta($wpuid, 'cred_next_expiry');
	
	// get user subscriptions
	$expires_in_secs = 60*60*24; // set to 1 day by default
	$subs = cred_get_contents("/api/user/subscriptions/".
	$username.".json?&api_key=".get_option("cred_api_key"));
	if ($subs == FALSE)  {
		return new WP_Error('error', __("Unable to connect to authentication server for subscriptions. Please try again later."));
	}
	$s = (array)json_decode($subs);
	if (is_array($s['subscriptions'])) {
		$s2 = array_map("cred_subscriptions_array_map", $s['subscriptions']);
		foreach($s['subscriptions'] as $k=>$v) {
			$av = (array) $v;
			$e = (integer)$av["expires_in_secs"];
			if ($e < $expires_in_secs) {
				$expires_in_secs = $e;
			}
		}
	} else {
		$s2 = array();
	}
	
   // manage expiry time
   $expiry = cred_add_date("now", $expires_in_secs);
	
   update_usermeta($wpuid, 'cred_subscriptions', $s2);
	update_usermeta($wpuid, 'cred_next_expiry', $expiry);
}

/* change the data from the server to a straight array with just the purchased content uri */
function cred_purchases_array_map($purchase) {
	$p = (array) $purchase;
	return (string)$p['uri'];
}

/* change the data from the server to a straight array with just the subscription type uri */
function cred_subscriptions_array_map($sub) {
	$s = (array) $sub;
	return (string)$s['type_uri'];
}

/* change wordpress username to reflect that they are from Cred */
function cred_username_to_wpusername($username) {
	return "cred_" . $username;
}
?>
